package com.swagger.rest.services

import com.swagger.rest.models.Comment
import com.swagger.rest.models.CommentInput
import com.swagger.rest.repositories.BugRepository
import com.swagger.rest.repositories.CommentRepository
import com.swagger.rest.repositories.UserRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.HttpStatus
import org.springframework.security.core.context.SecurityContextHolder
import org.springframework.stereotype.Service
import java.util.*

@Service
class CommentService {

    @Autowired
    private val commentRepository: CommentRepository? = null

    @Autowired
    private val userRepository: UserRepository? = null

    @Autowired
    private val bugRepository: BugRepository? = null

    fun saveComment(id: Long? = null, commentInput: CommentInput): Comment? {
        try {
            val save = Comment()
            save.bug = bugRepository!!.findById(id!!).get()
            save.creator = userRepository!!.getUserByUsername(SecurityContextHolder.getContext().authentication.name)
            save.created = Date()
            save.content = commentInput.content.trim()
            return commentRepository!!.save(save)
        } catch (e: Exception) {
            e.printStackTrace()
            return null
        }
    }

    fun validate(id: Long? = null, commentInput: CommentInput): HttpStatus? {
        try {
            val bug = bugRepository!!.findById(id!!)
            return if (bug.isPresent) {
                if (commentInput.content.isEmpty()) {
                    HttpStatus.BAD_REQUEST
                } else if (commentInput.content.length > 500) {
                    HttpStatus.PAYLOAD_TOO_LARGE
                } else {
                    HttpStatus.OK
                }
            } else {
                HttpStatus.NOT_FOUND
            }
        } catch (e: Exception) {
            e.printStackTrace()
            return HttpStatus.INTERNAL_SERVER_ERROR
        }
    }

}